diff --git a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 2f85fc7db..06235b798 100644
--- a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -2,48 +2,148 @@ package net.minecraft.core.util.collection;
 
 import net.minecraft.core.util.HardIllegalArgumentException;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-import java.util.Comparator;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
 
-public final class NamespaceID implements Comparator<NamespaceID>, Comparable<NamespaceID> {
-    public static final String DEFAULT_NAMESPACE = "minecraft";
-    public final String namespace;
-    public final String value;
-    public NamespaceID(String namespace, String value) throws IllegalArgumentException {
-        if (namespace.contains(":")) throw new IllegalArgumentException(namespace + " cannot contain the ':' character!");
-        if (value.contains(":")) throw new IllegalArgumentException(value + " cannot contain the ':' character!");
+public final class NamespaceID implements Comparable<NamespaceID>, CharSequence {
+    public static final @NotNull String DEFAULT_NAMESPACE = "minecraft";
+    private static final List<NamespaceID> pool = new ArrayList<>();
+    private static int poolPointer = 0;
+
+    public static @NotNull NamespaceID getPermanent(final @NotNull String formattedKey) throws HardIllegalArgumentException {
+        return new NamespaceID(formattedKey);
+    }
+
+    public static @NotNull NamespaceID getPermanent(final @NotNull String namespace, final @NotNull String value) {
+        return new NamespaceID(namespace, value);
+    }
+
+    public static @NotNull NamespaceID getTemp(final @NotNull String formattedKey) throws HardIllegalArgumentException {
+        if(poolPointer >= pool.size())
+        {
+            pool.add(getPermanent(formattedKey));
+        }
+        return pool.get(poolPointer++).set(formattedKey);
+    }
+
+    public static @NotNull NamespaceID getTemp(final @NotNull String namespace, final @NotNull String value) {
+        if(poolPointer >= pool.size())
+        {
+            pool.add(getPermanent(namespace, value));
+        }
+        return pool.get(poolPointer++).set(namespace, value);
+    }
+
+    public static void deinitializePool()
+    {
+        pool.clear();
+        poolPointer = 0;
+    }
+
+    public static void initializePool()
+    {
+        poolPointer = 0;
+    }
+
+    private @NotNull String fullString;
+    private @Nullable String namespace;
+    private @Nullable String value;
+
+    NamespaceID(final @NotNull String formattedKey) throws HardIllegalArgumentException {
+        set(formattedKey);
+    }
+
+    NamespaceID(final @NotNull String namespace, final @NotNull String value) {
+        set(namespace, value);
+    }
+
+    @NotNull
+    private NamespaceID set(final @NotNull String formattedKey) throws HardIllegalArgumentException {
+        Objects.requireNonNull(formattedKey);
+        final int firstIndex;
+        if ((firstIndex = formattedKey.indexOf(":")) != -1 && firstIndex == formattedKey.lastIndexOf(":") && firstIndex != 0 && firstIndex != formattedKey.length() - 1) {
+            this.fullString = formattedKey;
+            this.namespace = null;
+            this.value = null;
+        } else {
+            throw new HardIllegalArgumentException("Namespace id key must have exactly 1 ':' character in format <namespace>:<value>! " + formattedKey);
+        }
+        return this;
+    }
+
+    @NotNull
+    private NamespaceID set(final @NotNull String namespace, final @NotNull String value) {
+        Objects.requireNonNull(namespace);
+        Objects.requireNonNull(value);
+        if (namespace.contains(":")) throw new IllegalArgumentException("Namespace must not contain a ':', but was provided '" + namespace + "'!");
+        if (value.contains(":")) throw new IllegalArgumentException("Value must not contain a ':', but was provided '" + value + "'!");
+        this.fullString = namespace + ":" + value;
         this.namespace = namespace;
         this.value = value;
+        return this;
     }
-    public NamespaceID(String formattedString) throws HardIllegalArgumentException {
-        if (!formattedString.contains(":")) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' missing ':' character all namespace ids must follow the format <namespace>:<value>!");
-        String[] split = formattedString.split(":", 2);
-        if (split.length != 2 || split[0].isEmpty()) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' is missing namespace! all namespace ids must follow the format <namespace>:<value>!");
-        if (split[1].isEmpty()) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' is missing value! all namespace ids must follow the format <namespace>:<value>!");
-        if (split[1].contains(":")) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' has more then 1 ':' character! all namespace ids must follow the format <namespace>:<value>!");
-        namespace = split[0];
-        value = split[1];
+
+    @NotNull
+    public NamespaceID makePermanent(){
+        if (pool.contains(this)){
+            pool.remove(this);
+            poolPointer--;
+        }
+        return this;
+    }
+
+    public @NotNull String namespace() {
+        if (this.namespace == null) {
+            this.namespace = this.fullString.substring(0, this.fullString.indexOf(":"));
+        }
+        return this.namespace;
     }
+
+    public @NotNull String value() {
+        if (this.value == null) {
+            this.value = this.fullString.substring(this.fullString.indexOf(":") + 1);
+        }
+        return this.value;
+    }
+
     @Override
-    public int hashCode(){
-        return toString().hashCode();
+    public int length() {
+        return this.fullString.length();
     }
+
     @Override
-    public boolean equals(Object other){
-        if (other == null) return false;
-        return super.equals(other) | (other.toString().equals(this.toString()));
+    public char charAt(final int index) {
+        return this.fullString.charAt(index);
     }
+
     @Override
-    public String toString(){
-        return namespace + ":" + value;
+    public @NotNull CharSequence subSequence(final int start, final int end) {
+        return this.fullString.subSequence(start, end);
     }
+
     @Override
-    public int compare(NamespaceID o1, NamespaceID o2) {
-        return o1.toString().compareTo(o2.toString());
+    public @NotNull String toString() {
+        return this.fullString;
     }
 
     @Override
     public int compareTo(@NotNull NamespaceID o) {
-        return toString().compareTo(o.toString());
+        return this.fullString.compareTo(o.fullString);
+    }
+
+    @Override
+    public boolean equals(final Object o) {
+        if (o == null || getClass() != o.getClass()) return false;
+
+        final NamespaceID that = (NamespaceID) o;
+        return this.fullString.equals(that.fullString);
+    }
+
+    @Override
+    public int hashCode() {
+        return this.fullString.hashCode();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 98f67822b..d6aec1900 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2367,6 +2367,7 @@ public class World implements WorldSource {
         {
             caveSoundCounter--;
         }
+        final int randomTicks = getGameRuleValue(GameRules.RANDOM_TICK_SPEED);
         for (ChunkCoordinate coordinate : positionsToUpdate) {
             int chunkBlockX = coordinate.x * Chunk.CHUNK_SIZE_X;
             int chunkBlockZ = coordinate.z * Chunk.CHUNK_SIZE_Z;
@@ -2400,9 +2401,9 @@ public class World implements WorldSource {
                 int weatherBlockZ = (randVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
                 getCurrentWeather().doEnvironmentUpdate(this, rand, chunkBlockX + weatherBlockX, chunkBlockZ + weatherBlockZ);
             }
-            
+
             for (int s = 0; s < Chunk.CHUNK_SECTIONS; s++) {
-                for (int i = 0; i < getGameRuleValue(GameRules.RANDOM_TICK_SPEED); i++) {
+                for (int i = 0; i < randomTicks; i++) {
                     updateLCG = updateLCG * 3 + 0x3c6ef35f;
                     int iRandVal = updateLCG >> 2;
                     int iBlockX = iRandVal & (Chunk.CHUNK_SIZE_X - 1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index ebda87dcb..2b9e3f455 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -1,11 +1,6 @@
 package net.minecraft.core.world.biome;
 
-import net.minecraft.core.entity.animal.MobChicken;
-import net.minecraft.core.entity.animal.MobCow;
-import net.minecraft.core.entity.animal.MobFireflyCluster;
-import net.minecraft.core.entity.animal.MobPig;
-import net.minecraft.core.entity.animal.MobSheep;
-import net.minecraft.core.entity.animal.MobSquid;
+import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.MobCreeper;
 import net.minecraft.core.entity.monster.MobSkeleton;
 import net.minecraft.core.entity.monster.MobSlime;
@@ -58,6 +53,7 @@ public class Biome
         spawnableCreatureList.add(new SpawnListEntry(MobPig.class, 102));
         spawnableCreatureList.add(new SpawnListEntry(MobChicken.class, 102));
         spawnableCreatureList.add(new SpawnListEntry(MobCow.class, 102));
+        spawnableCreatureList.add(new SpawnListEntry(MobDeer.class, 10));
         spawnableWaterCreatureList.add(new SpawnListEntry(MobSquid.class, 10));
         spawnableAmbientCreatureList.add(new SpawnListEntry(MobFireflyCluster.class, 10));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
index fb153d8ad..be63f9911 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -63,7 +63,7 @@ public class SpawnerConfig {
         CompoundTag overrides = tag.getCompound("overrides");
         for (Map.Entry<String, Tag<?>> tagEntry : overrides.getValue().entrySet()) {
             try {
-                mobSpawnOverrides.put(new NamespaceID(tagEntry.getKey()), ((ByteTag)tagEntry.getValue()).getValue() != 0);
+                mobSpawnOverrides.put(NamespaceID.getPermanent(tagEntry.getKey()), ((ByteTag)tagEntry.getValue()).getValue() != 0);
             } catch (HardIllegalArgumentException e) {
                 LOGGER.error("Failed to convert string '{}' to namespace id!", tagEntry.getKey(), e);
             }
diff --git a/game/core/src/main/resources/lang/en_US/guidebook.lang b/game/core/src/main/resources/lang/en_US/guidebook.lang
index dcbbbf22b..8d3790296 100644
--- a/game/core/src/main/resources/lang/en_US/guidebook.lang
+++ b/game/core/src/main/resources/lang/en_US/guidebook.lang
@@ -34,6 +34,8 @@ guidebook.section.mob.cow.name=Cow
 guidebook.section.mob.cow.desc=Cows are useful as a source of leather, which can be used to create armor.\nThey can be found in most biomes.
 guidebook.section.mob.chicken.name=Chicken
 guidebook.section.mob.chicken.desc=Chickens are a source of feathers, which are useful for making arrows.\nThey can be found in most biomes.
+guidebook.section.mob.deer.name=Deer
+guidebook.section.mob.deer.desc=Deer are skittish animals found in cold climates. They provide an excellent source of food but are hard to catch.
 guidebook.section.mob.squid.name=Squid
 guidebook.section.mob.squid.desc=Squids are a source of ink sacs, which can be used to dye wool.\nThey can be found in lakes and oceans.
 guidebook.section.mob.wolf.name=Wolf
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index e57bb67ee..4ddd2d9bf 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -160,6 +160,10 @@ item.food.porkchop.raw.name=Raw Porkchop
 item.food.porkchop.raw.desc=Uncooked meat from a pig.
 item.food.porkchop.cooked.name=Cooked Porkchop
 item.food.porkchop.cooked.desc=Braised meat from a pig. Smoking!
+item.food.venison.raw.name=Raw Venison
+item.food.venison.raw.desc=Uncooked meat from a pig.
+item.food.venison.cooked.name=Cooked Venison
+item.food.venison.cooked.desc=Seared steak from a deer. Delicious!
 item.painting.name=Painting
 item.painting.desc=A lovely picture to hang on your wall.
 item.food.apple.gold.name=Golden Apple
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index ee6baeaff..1f471c10a 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -29,6 +29,7 @@ public class SmeltingGenerator {
 
         furnaceRecipe("fish_raw_to_fish_cooked", Items.FOOD_FISH_RAW.getDefaultStack(), Items.FOOD_FISH_COOKED.getDefaultStack());
         furnaceRecipe("porkchop_raw_to_porkchop_cooked", Items.FOOD_PORKCHOP_RAW.getDefaultStack(), Items.FOOD_PORKCHOP_COOKED.getDefaultStack());
+        furnaceRecipe("venison_raw_to_venison_cooked", Items.FOOD_VENISON_RAW.getDefaultStack(), Items.FOOD_VENISON_COOKED.getDefaultStack());
 
         furnaceRecipe("cobble_stone_to_stone", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.STONE.getDefaultStack());
         furnaceRecipe("cobble_basalt_to_basalt", Blocks.COBBLE_BASALT.getDefaultStack(), Blocks.BASALT.getDefaultStack());
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
index 0f597f9cd..0c6416598 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
@@ -22,7 +22,7 @@ public class TestChunkProvider implements ChunkProvider {
 
                     @Override
                     public NamespaceID getID() {
-                        return new NamespaceID("viewer", "test");
+                        return NamespaceID.getPermanent("viewer", "test");
                     }
 
                     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
index e3f61e1d5..38dadc049 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -20,7 +20,7 @@ public class BTABiome implements Biome {
     @Override
     public NamespaceID getID() {
         try {
-            return new NamespaceID(Registries.BIOMES.getKey(biome));
+            return NamespaceID.getPermanent(Registries.BIOMES.getKey(biome));
         } catch (HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
diff --git a/util/seed-viewer/src/test/java/collections/NamespaceTest.java b/util/seed-viewer/src/test/java/collections/NamespaceTest.java
index 1be1c8123..29f271278 100644
--- a/util/seed-viewer/src/test/java/collections/NamespaceTest.java
+++ b/util/seed-viewer/src/test/java/collections/NamespaceTest.java
@@ -11,77 +11,77 @@ public class NamespaceTest {
     @DisplayName("Test Namespace 2String Constructor")
     void namespaceCreation1() {
         // Valid creation
-        NamespaceID namespaceID_1 = new NamespaceID("minecraft", "value1");
-        Assertions.assertEquals(namespaceID_1.namespace, "minecraft");
-        Assertions.assertEquals(namespaceID_1.value, "value1");
+        NamespaceID namespaceID_1 = NamespaceID.getPermanent("minecraft", "value1");
+        Assertions.assertEquals(namespaceID_1.namespace(), "minecraft");
+        Assertions.assertEquals(namespaceID_1.value(), "value1");
         Assertions.assertEquals(namespaceID_1.toString(), "minecraft:value1");
 
-        NamespaceID namespaceID_2 = new NamespaceID("minecraft", "value1");
-        Assertions.assertEquals(namespaceID_2.namespace, "minecraft");
-        Assertions.assertEquals(namespaceID_2.value, "value1");
+        NamespaceID namespaceID_2 = NamespaceID.getPermanent("minecraft", "value1");
+        Assertions.assertEquals(namespaceID_2.namespace(), "minecraft");
+        Assertions.assertEquals(namespaceID_2.value(), "value1");
         Assertions.assertEquals(namespaceID_2.toString(), "minecraft:value1");
 
-        Assertions.assertEquals(namespaceID_1.namespace, namespaceID_2.namespace);
-        Assertions.assertEquals(namespaceID_1.value, namespaceID_2.value);
+        Assertions.assertEquals(namespaceID_1.namespace(), namespaceID_2.namespace());
+        Assertions.assertEquals(namespaceID_1.value(), namespaceID_2.value());
         Assertions.assertEquals(namespaceID_1, namespaceID_2);
         Assertions.assertEquals(namespaceID_1.toString(), namespaceID_2.toString());
 
-        NamespaceID namespaceID_3 = new NamespaceID("bta", "value2");
-        Assertions.assertEquals(namespaceID_3.namespace, "bta");
-        Assertions.assertEquals(namespaceID_3.value, "value2");
+        NamespaceID namespaceID_3 = NamespaceID.getPermanent("bta", "value2");
+        Assertions.assertEquals(namespaceID_3.namespace(), "bta");
+        Assertions.assertEquals(namespaceID_3.value(), "value2");
         Assertions.assertEquals(namespaceID_3.toString(), "bta:value2");
 
-        Assertions.assertNotEquals(namespaceID_3.namespace, "minecraft");
-        Assertions.assertNotEquals(namespaceID_3.value, "value1");
+        Assertions.assertNotEquals(namespaceID_3.namespace(), "minecraft");
+        Assertions.assertNotEquals(namespaceID_3.value(), "value1");
         Assertions.assertNotEquals(namespaceID_3.toString(), "minecraft:value1");
 
         Assertions.assertNotEquals(namespaceID_3, namespaceID_1);
-        Assertions.assertNotEquals(namespaceID_3.value, namespaceID_1.value);
-        Assertions.assertNotEquals(namespaceID_3.namespace, namespaceID_1.namespace);
+        Assertions.assertNotEquals(namespaceID_3.value(), namespaceID_1.value());
+        Assertions.assertNotEquals(namespaceID_3.namespace(), namespaceID_1.namespace());
         Assertions.assertNotEquals(namespaceID_3.toString(), namespaceID_1.toString());
 
         Assertions.assertNotEquals(namespaceID_3, namespaceID_2);
-        Assertions.assertNotEquals(namespaceID_3.value, namespaceID_2.value);
-        Assertions.assertNotEquals(namespaceID_3.namespace, namespaceID_2.namespace);
+        Assertions.assertNotEquals(namespaceID_3.value(), namespaceID_2.value());
+        Assertions.assertNotEquals(namespaceID_3.namespace(), namespaceID_2.namespace());
         Assertions.assertNotEquals(namespaceID_3.toString(), namespaceID_2.toString());
 
         // Invalid creation
-        Assertions.assertThrowsExactly(NullPointerException.class, () -> new NamespaceID(null, null));
-        Assertions.assertThrowsExactly(NullPointerException.class, () -> new NamespaceID("minecraft", null));
-        Assertions.assertThrowsExactly(NullPointerException.class, () -> new NamespaceID(null, "value1"));
+        Assertions.assertThrowsExactly(NullPointerException.class, () -> NamespaceID.getPermanent(null, null));
+        Assertions.assertThrowsExactly(NullPointerException.class, () -> NamespaceID.getPermanent("minecraft", null));
+        Assertions.assertThrowsExactly(NullPointerException.class, () -> NamespaceID.getPermanent(null, "value1"));
 
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft:", "value1"));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft", "value1:"));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft:", "value1:"));
+        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft:", "value1"));
+        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft", "value1:"));
+        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft:", "value1:"));
     }
 
     @Test
     @DisplayName("Test Namespace 1String Constructor")
     void namespaceCreation2() throws HardIllegalArgumentException {
         String formatted_1 = "minecraft:value1";
-        NamespaceID namespaceID_1 = new NamespaceID(formatted_1);
-        Assertions.assertEquals(namespaceID_1.namespace, "minecraft");
-        Assertions.assertEquals(namespaceID_1.value, "value1");
+        NamespaceID namespaceID_1 = NamespaceID.getPermanent(formatted_1);
+        Assertions.assertEquals(namespaceID_1.namespace(), "minecraft");
+        Assertions.assertEquals(namespaceID_1.value(), "value1");
         Assertions.assertEquals(namespaceID_1.toString(), formatted_1);
-        Assertions.assertEquals(namespaceID_1.namespace + ":" + namespaceID_1.value, formatted_1);
+        Assertions.assertEquals(namespaceID_1.namespace() + ":" + namespaceID_1.value(), formatted_1);
 
-        NamespaceID namespaceID_2 = new NamespaceID(formatted_1);
-        Assertions.assertEquals(namespaceID_2.namespace, "minecraft");
-        Assertions.assertEquals(namespaceID_2.value, "value1");
+        NamespaceID namespaceID_2 = NamespaceID.getPermanent(formatted_1);
+        Assertions.assertEquals(namespaceID_2.namespace(), "minecraft");
+        Assertions.assertEquals(namespaceID_2.value(), "value1");
         Assertions.assertEquals(namespaceID_2.toString(), formatted_1);
-        Assertions.assertEquals(namespaceID_2.namespace + ":" + namespaceID_2.value, formatted_1);
+        Assertions.assertEquals(namespaceID_2.namespace() + ":" + namespaceID_2.value(), formatted_1);
 
-        Assertions.assertEquals(namespaceID_1.namespace, namespaceID_2.namespace);
-        Assertions.assertEquals(namespaceID_1.value, namespaceID_2.value);
+        Assertions.assertEquals(namespaceID_1.namespace(), namespaceID_2.namespace());
+        Assertions.assertEquals(namespaceID_1.value(), namespaceID_2.value());
         Assertions.assertEquals(namespaceID_1, namespaceID_2);
         Assertions.assertEquals(namespaceID_1.toString(), namespaceID_2.toString());
 
-        Assertions.assertThrowsExactly(NullPointerException.class, () -> new NamespaceID(null));
-        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft::value1"));
-        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft:value1:"));
-        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID(":value1"));
-        Assertions.assertDoesNotThrow(() -> new NamespaceID("minecraft:value"));
-        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft value"));
-        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft|value"));
+        Assertions.assertThrowsExactly(NullPointerException.class, () -> NamespaceID.getPermanent(null));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft::value1"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft:value1:"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> NamespaceID.getPermanent(":value1"));
+        Assertions.assertDoesNotThrow(() -> NamespaceID.getPermanent("minecraft:value"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft value"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> NamespaceID.getPermanent("minecraft|value"));
     }
 }
